// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  FreeStringReferenceArray(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function FreeStringReferenceArray(stringReferencesArray){
  var i;
  for(i = 0; i < stringReferencesArray.length; i = i + 1){
    delete(stringReferencesArray[i]);
  }
  delete(stringReferencesArray);
}
function test(){
  var failures;
  var booleanReference;
  var booleanArray;
  var booleanArrayReference1, booleanArrayReference2;
  var characterReference;
  var numberReference;
  var numberArrayReference1, numberArrayReference2;
  var numberArray;
  var stringReference;
  var stringReferenceArray;
  var stringArrayReference1, stringArrayReference2;

  failures = 0;

  booleanReference = CreateBooleanReference(true);
  booleanArray = [];
  booleanArray.length = 4;
  booleanArrayReference1 = CreateBooleanArrayReference(booleanArray);
  booleanArrayReference2 = CreateBooleanArrayReferenceLengthValue(8, true);
  characterReference = CreateCharacterReference('a');
  numberReference = CreateNumberReference(4);
  numberArray = [];
  numberArray.length = 6;
  numberArrayReference1 = CreateNumberArrayReference(numberArray);
  numberArrayReference2 = CreateNumberArrayReferenceLengthValue(6, 2);
  stringReference = CreateStringReference("hi".split(''));
  stringReferenceArray = [];
  stringReferenceArray.length = 2;
  stringReferenceArray[0] = CreateStringReference("Hello".split(''));
  stringReferenceArray[1] = CreateStringReference("World".split(''));
  stringArrayReference1 = CreateStringArrayReference(stringReferenceArray);
  stringArrayReference2 = CreateStringArrayReferenceLengthValue(5, "".split(''));

  FreeBooleanArrayReference(booleanArrayReference1);
  FreeBooleanArrayReference(booleanArrayReference2);

  FreeNumberArrayReference(numberArrayReference1);
  FreeNumberArrayReference(numberArrayReference2);

  delete(stringReference);

  FreeStringArrayReference(stringArrayReference1);
  FreeStringArrayReference(stringArrayReference2);

  return failures;
}


module.exports = {
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	FreeStringReferenceArray: FreeStringReferenceArray,
	test: test
};